      SUBROUTINE AZIRN(SN,CS)
C**** PURPOSE:  RETURNS SINGLE PRECISION VALUES OF THE SINE AND COSINE
C****           OF A UNIFORMLY DISTRIBUTED RANDOM AZIMUTHAL ANGLE
C****           IN THE OPEN INTERVAL (0, 2*PI) RADIANS.
C
C**** ARGUMENTS:
C**** SN     = SINE OF UNIFORMLY DISTRIBUTED AZIMUTHAL ANGLE
C**** CS     = COSINE OF UNIFORMLY DISTRIBUTED AZIMUTHAL ANGLE
C
C**** SUBPROGRAMS CALLED:
C**** FLTRN  - RETURNS SINGLE PRECISION UNIFORMLY DISTRIBUTED RANDOM
C****          NUMBER IN THE OPEN INTERVAL (0,1)
C**** SIN    - GENERIC NAME FOR SINE INTRINSIC FUNCTION
C**** COS    - GENERIC NAME FOR COSINE INTRINSIC FUNCTION
C
      REAL THETA,FLTRN,TWOPI
      REAL SN,CS
      PARAMETER (TWOPI=6.2831853E0)
C
      THETA = TWOPI*FLTRN()
      SN = SIN(THETA)
      CS = COS(THETA)
      RETURN
      END
