      SUBROUTINE GTISO(U,V,W)
C**** PURPOSE:  RETURNS SINGLE PRECISION DIRECTION COSINES FOR A
C****           RANDOM DIRECTION UNIFORMLY SELECTED FROM 4*PI
C****           STERADIANS
C
C**** ARGUMENTS:
C**** U      = DIRECTION COSINE WITH RESPECT TO X-AXIS
C**** V      = DIRECTION COSINE WITH RESPECT TO Y-AXIS
C**** W      = DIRECTION COSINE WITH RESPECT TO Z-AXIS
C
C**** SUBPROGRAMS CALLED:
C**** FLTRN  - RETURNS SINGLE PRECISION UNIFORMLY DISTRIBUTED RANDOM
C****          NUMBER IN THE OPEN INTERVAL (0,1)
C**** SIN    - GENERIC NAME FOR SINE INTRINSIC FUNCTION
C**** COS    - GENERIC NAME FOR COSINE INTRINSIC FUNCTION
C**** SQRT   - GENERIC NAME FOR SQUARE ROOT INTRINSIC FUNCTION
C
      REAL U,V,W
      REAL TWOPI,THETA,FLTRN,SN,CS,UV
      PARAMETER (TWOPI=6.2831853E0)
C
      W = -1.E0+2.E0*FLTRN()
      THETA = TWOPI*FLTRN()
      SN = SIN(THETA)
      CS = COS(THETA)
      UV = SQRT(1.E0-W**2)
      U = CS*UV
      V = SN*UV
      RETURN
      END
