************************************************************************
*     TEST OF VARIOUS RANDOM NUMBER GENERATORS                         *
*     THIS VERSION USES TIMING FUNCTIONS FROM MICROSOFT FORTRAN        *
************************************************************************
*     FUNCTIONS ARE IN PROGRAM PACKAGE RANPAK                          *
************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /PARKS/ SEED
      COMMON /PARKD/ DSEED
      INTEGER IXX,SEED
      REAL Y,YMAX,YMIN,FLTRN
1     CONTINUE
      PRINT *, ' ENTER INTEGER TO SELECT GENERATOR'
      PRINT *, '   0      - TO STOP'
      PRINT *, '   1 EGS4 - DOUBLE PRECISION VERSION'
      PRINT *, '   2 PARK - DBLE PRECISION, INTEGER ARITHMETIC'
      PRINT *, '   3 PARK - DBLE PRECISION, DBLE PRECISION ARITHMETIC'
      PRINT *, '   4 PARK - SNGLE PRECISION, INTEGER ARITHMETIC'
      READ *, NSEL
      IF(NSEL.EQ.0) GO TO 999
      IXX = 1
      DSEED = 1.D0
      SEED = 1
      ZMAX = .5D0
      YMAX = .5E0
      ZMIN = .5D0
      YMIN = .5E0
      PRINT *, 'ENTER NUMBER OF RANDOM NUMBERS'
      READ *, N
      IF(N.EQ.0) GO TO 999
      DSEED = 1.D0
C     CALL GETTIM(IHR,IMIN,ISEC,I100TH)
C     TIMESTART = REAL(3600*IHR+60*IMIN+ISEC)+REAL(I100TH)/100
      DO 100 I = 1,N
      IF(NSEL.EQ.1) THEN
        Z = RAN(IXX)
      ELSEIF(NSEL.EQ.2) THEN
        Z = FLTRNI()
      ELSEIF(NSEL.EQ.4) THEN
        Y = FLTRN()
      ELSE
        Z = FLTRNF()
      END IF
      IF(NSEL.EQ.4) THEN
        YMAX = MAX(Y,YMAX)
        YMIN = MIN(Y,YMIN)
        IF(Y.GE.1.E0.OR.Y.LE.0.E0) THEN
          PRINT *,'N, Y =', I,Y
          STOP
        END IF
      ELSE
        ZMAX = DMAX1(Z,ZMAX)
        ZMIN = DMIN1(Z,ZMIN)
      END IF
100   CONTINUE
C     CALL GETTIM(IHR,IMIN,ISEC,I100TH)
C     TIMENOW = REAL(3600*IHR+60*IMIN+ISEC)+REAL(I100TH)/100.

      IF(NSEL.EQ.4) THEN
        PRINT *, ' YMAX = ',YMAX
        PRINT *, ' YMIN = ',YMIN
      ELSE
        PRINT *, ' ZMAX = ',ZMAX
        PRINT *, ' ZMIN = ',ZMIN
      END IF
      IF(NSEL.EQ.3) THEN
        PRINT *, ' SEED = ',DSEED
      ELSEIF(NSEL.EQ.4.OR.NSEL.EQ.2) THEN
        PRINT *, ' SEED = ',SEED
      ELSE
        PRINT *, ' SEED = ',IXX
      ENDIF
C     PRINT *, 'SECONDS = ',(TIMENOW-TIMESTART)
      GO TO 1
999   STOP
      END
************************************************************************
**********                                                   ***********
**********                      RANPAK  V. 1                 ***********
**********                                                   ***********
*********  SUBPROGRAMS FOR MONTE CARLO TRANSPORT CALCULATIONS **********
**********                                                   ***********
**********                                                   ***********
************************************************************************
**********                                                   ***********
**********                    RICHARD E. FAW                 ***********
**********             NUCLEAR ENGINEERING DEPARTMENT        ***********
**********                 KANSAS STATE UNIVERSITY           ***********
**********               MANHATTAN, KANSAS 66506-2503        ***********
**********                     913-532-5963                  ***********
**********                                                   ***********
************************************************************************


************************************************************************
**********               RANDOM NUMBER GENERATORS            ***********
************************************************************************

*     FLTRN() IS A PREFERRED SINGLE PRECISION GENERATOR
*     >>> COMMON /PARKS/ SEED <<<  IS REQUIRED IN CALLING PROGRAM
*     INTEGER >> SEED << MUST BE INITIALIZED IN CALLING PROGRAM
*     AND MUST BE CARRIED IN COMMON WITHIN ALL CALLING PROGRAMS
*-----------------------------------------------------------------------
*     FLTRNI() IS A PREFERRED DOUBLE PRECISION GENERATOR
*     >>> COMMON /PARKS/ SEED <<<  IS REQUIRED IN CALLING PROGRAM
*     INTEGER >> SEED << MUST BE INITIALIZED IN CALLING PROGRAM
*     AND MUST BE CARRIED IN COMMON WITHIN ALL CALLING PROGRAMS
*-----------------------------------------------------------------------
*     FLTRNF() IS A PREFERRED DOUBLE PRECISION GENERATOR
*     >>> COMMON /PARKD / DSEED <<<  IS REQUIRED IN CALLING PROGRAM
*     REAL*8 >> DSEED << MUST BE INITIALIZED IN CALLING PROGRAM
*     AND MUST BE CARRIED IN COMMON WITHIN ALL CALLING PROGRAMS
*-----------------------------------------------------------------------
*     RAN(IXX) IS A DOUBLE PRECISION GENERATOR
*     THE DOUBLE PRECISION VERSION OF THE EGS4 GENERATOR
*     INTEGER >> IXX << MUST BE INITIALIZED IN CALLING PROGRAM
*     AND MUST BE CARRIED IN COMMON WITHIN ALL CALLING PROGRAMS
*-----------------------------------------------------------------------
      REAL FUNCTION FLTRN()
      COMMON /PARKS/ SEED
      INTEGER TEST, SEED
      TEST = 16807*MOD(SEED,127773)-SEED/127773*2836
      IF (TEST.GT.0) THEN
         SEED = TEST
      ELSE
         SEED = TEST + 2147483647
      END IF
      FLTRN = 4.656612E-10*SEED
      RETURN
      END
*-----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION RAN(IXX)
      INTEGER IXX
      IXX = IXX*663608941
      RAN = .5D0 + IXX*.232830643762289846D-9
      RETURN
      END
*-----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FLTRNF()
      DOUBLE PRECISION A,M,B,TEMP,DSEED
      COMMON /PARKD /DSEED
      PARAMETER(A=16807.D0,M=2147483647.D0)
      PARAMETER(B=.465661287524579692D-9)
      TEMP  = DSEED*A
      DSEED = TEMP -M*INT(TEMP*B)
      FLTRNF = DSEED*B
      RETURN
      END
*-----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION FLTRNI()
      INTEGER A,M,Q,R,LO,HI,TEST,SEED
      DOUBLE PRECISION MINV
      COMMON /PARKS/ SEED
      PARAMETER(A=16807,M=2147483647,Q=127773,R=2836)
      PARAMETER(MINV=.465661287416159476D-9)
      HI=SEED/Q
      LO=MOD(SEED,Q)
      TEST=A*LO-R*HI
      IF(TEST.GT.0) THEN
         SEED=TEST
      ELSE
         SEED=TEST+M
      ENDIF
      FLTRNI = MINV*DBLE(SEED)
      RETURN
      END
************************************************************************
